## net.i2p.stat
Class StatManager

    java.lang.Object
      net.i2p.stat.StatManager

    public class StatManager

extends java.lang.Object

Coordinate the management of various frequencies and rates within I2P components, both allowing central update and retrieval, as well as distributed creation and use. This does not provide any persistence, but the data structures exposed can be read and updated to manage the complete state.

Field Summary
`static java.lang.String` `DEFAULT_STAT_FILE`
`static java.lang.String` `PROP_STAT_FILE`
`static java.lang.String` `PROP_STAT_FILTER`

Constructor Summary
`StatManager(I2PAppContext context)` The stat manager should only be constructed and accessed through the application context.

Method Summary
`void` `addRateData(java.lang.String name, long data, long eventDuration)` update the given rate statistic, taking note that the given data point was received (and recalculating all rates)
`void` `coalesceStats()`
`void` `createFrequencyStat(java.lang.String name, java.lang.String description, java.lang.String group, long[] periods)` Create a new statistic to monitor the frequency of some event.
`void` `createRateStat(java.lang.String name, java.lang.String description, java.lang.String group, long[] periods)` Create a new statistic to monitor the average value and confidence of some action.
`FrequencyStat` `getFrequency(java.lang.String name)`
`java.util.Set` `getFrequencyNames()`
`RateStat` `getRate(java.lang.String name)`
`java.util.Set` `getRateNames()`
`java.lang.String` `getStatFile()`
`java.lang.String` `getStatFilter()`
`StatLog` `getStatLog()`
`java.util.Map` `getStatsByGroup()` Group name (String) to a Set of stat names, ordered alphabetically
`boolean` `isFrequency(java.lang.String statName)` is the given stat a monitored frequency?
`boolean` `isRate(java.lang.String statName)` is the given stat a monitored rate?
`void` `setStatLog(StatLog log)`
`void` `updateFrequency(java.lang.String name)` update the given frequency statistic, taking note that an event occurred (and recalculating all frequencies)

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### PROP_STAT_FILTER

    public static final java.lang.String PROP_STAT_FILTER

See Also:
  Constant Field Values

### PROP_STAT_FILE

    public static final java.lang.String PROP_STAT_FILE

See Also:
  Constant Field Values

### DEFAULT_STAT_FILE

    public static final java.lang.String DEFAULT_STAT_FILE

See Also:
  Constant Field Values

Constructor Detail

### StatManager

    public StatManager(I2PAppContext context)

  The stat manager should only be constructed and accessed through the application context. This constructor should only be used by the appropriate application context itself.

Method Detail

### getStatLog

    public StatLog getStatLog()

### setStatLog

    public void setStatLog(StatLog log)

### createFrequencyStat

    public void createFrequencyStat(java.lang.String name,
                                    java.lang.String description,
                                    java.lang.String group,
                                    long[] periods)

  Create a new statistic to monitor the frequency of some event.

  Parameters:
    `name` - unique name of the statistic
    `description` - simple description of the statistic
    `group` - used to group statistics together
    `periods` - array of period lengths (in milliseconds)

### createRateStat

    public void createRateStat(java.lang.String name,
                               java.lang.String description,
                               java.lang.String group,
                               long[] periods)

  Create a new statistic to monitor the average value and confidence of some action.

  Parameters:
    `name` - unique name of the statistic
    `description` - simple description of the statistic
    `group` - used to group statistics together
    `periods` - array of period lengths (in milliseconds)

### updateFrequency

    public void updateFrequency(java.lang.String name)

  update the given frequency statistic, taking note that an event occurred (and recalculating all frequencies)

### addRateData

    public void addRateData(java.lang.String name,
                            long data,
                            long eventDuration)

  update the given rate statistic, taking note that the given data point was received (and recalculating all rates)

### coalesceStats

    public void coalesceStats()

### getFrequency

    public FrequencyStat getFrequency(java.lang.String name)

### getRate

    public RateStat getRate(java.lang.String name)

### getFrequencyNames

    public java.util.Set getFrequencyNames()

### getRateNames

    public java.util.Set getRateNames()

### isRate

    public boolean isRate(java.lang.String statName)

  is the given stat a monitored rate?

### isFrequency

    public boolean isFrequency(java.lang.String statName)

  is the given stat a monitored frequency?

### getStatsByGroup

    public java.util.Map getStatsByGroup()

  Group name (String) to a Set of stat names, ordered alphabetically

### getStatFilter

    public java.lang.String getStatFilter()

### getStatFile

    public java.lang.String getStatFile()